package gov.fnal.eag.shapelets.functions;

/**
 * implements eq 6 of paper II to create two dimensional convolution tensor.
 * 
 * @author kuropat
 * 
 */
public class CCTensor extends CTensor {
	//private static double sqrt2 = Math.sqrt(2.0);

	//private static double sqrtPI = Math.sqrt(Math.PI);

	private int[][] ind;

	private int aSize = 0;

	protected double[][][] CC;

	/**
	 * fully specified constructor
	 * 
	 * @param gamma scale factor of the convolved image
	 * @param alpha scale factor of the original image
	 * @param beta scale factor of the PSF image
	 * @param nMax maximum order to evaluate
	 */
	public CCTensor(double gamma, // scale factor of the convolved image
			double alpha, // scale factor of the original image
			double beta, // scale factor of the PSF image
			int nMax) {
		super(gamma, alpha, beta, nMax);
		ind = BasisFunction.ind; 
		aSize = (nMax + 1) * (nMax + 2) / 2;
		CC = new double[aSize+1][aSize+1][aSize+1];
		//int i = 0;
		//int j = 0;
		//int k = 0;
		for (int n = 0; n < aSize; n++) {
			for (int m = 0; m < aSize; m++) {
				for (int l = 0; l < aSize; l++) {
					CC[n][m][l] = 0.;
					CC[n][m][l] = ct[ind[0][n]][ind[0][m]][ind[0][l]]
							* ct[ind[1][n]][ind[1][m]][ind[1][l]];

				}
			}

		}
	}
}