package gov.fnal.eag.shapelets.functions;

/**
 * stores the values of factorial from 0 through nMax.
 * 
 * @author stoughto
 */
public class Factorial {
	protected static double[] factorial;
	private static int nMaxFactorial;
	static {
		nMaxFactorial = Hermite.nMaxHermite + 10; // 40
		factorial = new double[nMaxFactorial];
		factorial[0] = 1;
		for (int i=1; i<nMaxFactorial; i++) {
			factorial[i] = i*factorial[i-1];
		}
	}
	/**
	 * @return the number of integers that have factorial computed
	 */
	public static int getNMax() {
		return nMaxFactorial;
	}
	/**
	 * @return the vector of factorial values
	 */
	public static double[] getFactorial() {
		return factorial;
	}
}
