/*
 * Created on Nov 10, 2004
 *
 * @author stoughto
 */
package gov.fnal.eag.shapelets.functions;

/**
 * implements equation 1 of paper 1
 */
public class Phi extends Hermite {
	private static double[] coeff;
	static int nMaxPhi;

	static {
		nMaxPhi = nMaxHermite-1;    // 19
		double sqrtPI = Math.sqrt(Math.PI);
		coeff = new double[nMaxPhi];
		for (int n=0; n<nMaxPhi; n++) {
			coeff[n] = Math.sqrt(Math.pow(2.0, n) * sqrtPI * Factorial.factorial[n]);
		}
	}
	
	/**
	 * evaluate phi
	 * @param n the order to evaluate
	 * @param x location to evaluate
	 * @return the value of phi
	 */
	public static double evaluatePhi(int n, double x) {
		double he = H[n].evaluate(x);
		double exp = Math.exp(-x*x/2.0);
		double retval =  he * exp / coeff[n];
		//System.out.println("evaluatePhi:  n="+n+" x="+x+" retval="+retval);
		return retval;
	}
	
	public static int getNMax() {
		return nMaxPhi;
	}

	/**
	 * @return the coefficients
	 */
	
	public static double[] getCoeff() {
		return coeff;
	}

	
}
