package gov.fnal.eag.sim.catalog;

import gov.fnal.eag.wcs.SphericalCoordinate;

/**
 * Generates random spherical coordinates within a specified range.
 * 
 * @author neilsen
 * @version $Name:  $ ($Id: CoordinateGenerator.java,v 1.11 2008/02/29 16:56:20 descvs Exp $)
 */
public interface CoordinateGenerator extends Iterable<SphericalCoordinate> {
	
	/**
	 * HTM depth for seeding random numbers based on position
	 */
	public static int depth = 13;

	/**
   * @return the area covered by this generator, in steradians
   */
  public double steradians();
  
  /**
   * @return a deep copy of this 
   */
  public CoordinateGenerator copy();
  
  /**
   * @return the seed used for this generator
   */
  public int getISeed();
  
  
}


