package gov.fnal.eag.sim.catalog;

import gov.fnal.eag.wcs.SphericalCoordinate;

/**
 * generates Morphology
 * @author stoughto
 *
 */
public interface MorphologyGenerator {

	/**
	 * @param calculateReturnValue if true calculate the return value; if false, simply call the random number generators the appropriate number of times
	 * @return the next Morphology
	 */
	public Morphology next(boolean calculateReturnValue);
	
	/**
	 * @return a deep copy
	 */
	public MorphologyGenerator copy();

	/**
	 * @return the index to the random number seeds
	 */
	public int getISeed();

	
	/**
	 * @param sc
	 * @param absoluteMagnitude 
	 * @param redshift 
	 * @return the next morphology based on the coordinate, redshift, and absolute magnitude
	 */
	public Morphology next(SphericalCoordinate sc, double redshift, double absoluteMagnitude);
	
}
