package gov.fnal.eag.sim.catalog;

import gov.fnal.eag.wcs.SphericalCoordinate;

/**
 * always returns the same morphology
 * @author stoughto
 *
 */
public class MorphologyGeneratorConstant implements MorphologyGenerator {

	Morphology morphology;
	
	/**
	 * Fully-specified constructor 
	 * @param morphology gets returned by the next method
	 */
	public MorphologyGeneratorConstant(Morphology morphology) {
		this.morphology = morphology;
	}
	
	/**
	 * @see gov.fnal.eag.sim.catalog.MorphologyGenerator#copy()
	 */
	public MorphologyGenerator copy() {
		return new MorphologyGeneratorConstant(morphology);
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.MorphologyGenerator#getISeed()
	 */
	public int getISeed() {
		return 0;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.MorphologyGenerator#next(boolean)
	 */
	public Morphology next(boolean isContained) {
		return morphology;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.MorphologyGenerator#next(gov.fnal.eag.wcs.SphericalCoordinate, double, double)
	 */
	public Morphology next(SphericalCoordinate sc, double redshift, double absoluteMagnitude) {
		return morphology;
	}

}
