package gov.fnal.eag.sim.catalog;

import gov.fnal.eag.sim.random.SimRandomRedshift;

/**
 * generation of redshifts from min to max, in order, with the defined number of steps
 * @author stoughto
 *
 */
public class RedshiftSequence extends SimRandomRedshift {
	double redshiftMin, redshiftMax;
	int nRedshift;
	int iRedshift = 0;
	
	/**
	 * creates a sequence of redshifts from min to max
	 * @param redshiftMin
	 * @param redshiftMax
	 * @param nRedshift
	 */
	public RedshiftSequence(double redshiftMin, double redshiftMax, int nRedshift) {
		this.redshiftMin = redshiftMin;
		this.redshiftMax = redshiftMax;
		this.nRedshift = nRedshift;
		
	}

	/**
	 * @see gov.fnal.eag.sim.random.SimRandomDistribution#next()
	 */
	@Override
	public double next() {
		if (nRedshift < 2) {
			return redshiftMin;
		}
		int index = iRedshift%nRedshift;
		double retval = redshiftMin + index*(redshiftMax-redshiftMin)/(nRedshift-1);
		iRedshift++;
		return retval;
	}
	
	/**
	 * @see gov.fnal.eag.sim.random.SimRandomDistribution#next(boolean)
	 */
	@Override
	public double next(boolean isContained) {
		return next();
	}
	

}
