package gov.fnal.eag.sim.catalog;

import gov.fnal.eag.wcs.SphericalCoordinate;


/**
 * Interface used to generate random SEDs.
 * @author neilsen
 * @version $Name:  $ ($Id: SEDGenerator.java,v 1.9 2008/07/20 16:33:19 descvs Exp $)
 */
public interface SEDGenerator {

	//private double currentMagnitude = Double.NaN;

	/**
	 * Create a new SED and return it.
	 * 
	 * @return the next SED
	 */
	public  SED next();

	/**
	 * @param returnValue
	 * @return the next value, or null if returnValue is false
	 */
	public SED next(boolean returnValue);
	/**
	 * @return a deep copy
	 */
	public SEDGenerator copy();

	/**
	 * @return the seed for this generator
	 */
	public int getISeed();

	/**
	 * @return the WavelengthScale for this generator
	 */
	public WavelengthScale getWavelengthScale();

	/**
	 * @param sc
	 * @return the next SED
	 */
	public SED next(SphericalCoordinate sc);


}

