package gov.fnal.eag.sim.catalog;

import java.util.ArrayList;

import gov.fnal.eag.sim.random.SimRandomUniform;
import gov.fnal.eag.wcs.SphericalCoordinate;

/**
 * picks one of the SEDS each time
 * @author stoughto
 *
 */
public class SEDGeneratorUniform implements SEDGenerator {

	ArrayList<SED> seds;
	SimRandomUniform sru;

	/**
	 * @param seds
	 * @param sru
	 */
	public SEDGeneratorUniform(ArrayList<SED> seds, SimRandomUniform sru) {
		this.seds = seds;
		this.sru = sru;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#copy()
	 */
	public SEDGenerator copy() {

		SimRandomUniform sruCopy = new SimRandomUniform(sru.getIseedIndex());
		for (int i=0; i<sru.getIgenerated(); i++) {
			sruCopy.next();
		}
		ArrayList<SED> clone = new ArrayList<SED>();
		clone.addAll(seds);
		SEDGenerator retval = new SEDGeneratorUniform(clone, sruCopy);
		return retval;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#getISeed()
	 */
	public int getISeed() {
		int retval = sru.getIseedIndex();
		return retval;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#getWavelengthScale()
	 */
	public WavelengthScale getWavelengthScale() {
		return null;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#next()
	 */
	public SED next() {
		return next(true);
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#next(boolean)
	 */
	public SED next(boolean returnValue) {
		int index = (int) sru.next(0.0, seds.size()+1);
		SED retval = null;
		if (returnValue) {
			retval = seds.get(index).clone();
		}
		return retval;
	}

	/**
	 * @see gov.fnal.eag.sim.catalog.SEDGenerator#next(gov.fnal.eag.wcs.SphericalCoordinate)
	 */
	public SED next(SphericalCoordinate sc) {
		return next(true);
	}

}
