/**
 * 
 */
package gov.fnal.eag.sim.catalog;


/**
 * a {@link gov.fnal.eag.sim.catalog.WavelengthBin} and its corresponding value
 * 
 * @author neilsen
 * @version $Name:  $ ($Id: ValuedBin.java,v 1.8 2008/08/04 17:05:03 descvs Exp $)
 * 
 */
public class ValuedBin {
	//Fields
	private WavelengthBin wavelengthBin = null; // The wavelength bin
	private Double value = null;
	
	//Methods
	//Constructors
	/**
	 * Create a wavelength bin.
	 * 
	 * @param wavelengthBin the bin to create
	 * @param value the value for that bin
	 */
	public ValuedBin(WavelengthBin wavelengthBin, Double value) {
		setWavelengthBin(wavelengthBin);
		setValue(value);
	}
	
	/**
	 * Set the wavelength range of the bin
	 * 
	 * @param wavelengthBin the new wavelength bin
	 */
	public void setWavelengthBin(WavelengthBin wavelengthBin) {
		this.wavelengthBin = wavelengthBin;
	}

	/**
	 * Get the wavelength range of the bin.
	 * 
	 * @return the wavelength bin
	 */
	public WavelengthBin getWavelengthBin() {
		return this.wavelengthBin;
	}
	
	
	/**
	 * Set the value of the bin.
	 * 
	 * @param value the new value of the bin
	 */
	public void setValue(Double value) {
		this.value = value;
	}
	
	/**
	 * Get the value of the bin.
	 * 
	 * @return the value of the bin
	 */
	public double getValue() {
		return value;
	}
	
	/**
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		String retval = super.toString()+" value="+value.doubleValue()+" bin="+wavelengthBin;
		return retval;
	}
}