/**
 * Provides the classes necessary for generating simulated catalogs of astronomical objects. 
 * <p>
 * The highest level object in this class heirarchy is the 
 * {@link gov.fnal.eag.sim.catalog.AstroCatalogGenerator}, which contains
 * a list of {@link gov.fnal.eag.sim.catalog.AstroObjectGenerator}s, a list
 * of the numbers of objects to be created by each generator, and a URL to
 * which to write the generate catalog.
 * <p>
 * Each {@link gov.fnal.eag.sim.catalog.AstroObjectGenerator} has a 
 * {@link gov.fnal.eag.sim.catalog.AstroObjectGenerator#next()} method that
 * returns an {@link gov.fnal.eag.sim.catalog.AstroObject}. The specific
 * subclass of the generator and the attributes of its instantiation determine
 * how the {@link gov.fnal.eag.sim.catalog.AstroObject} is generated.
 * <p>
 * Each {@link gov.fnal.eag.sim.catalog.AstroObject} has attributes describing
 * the position, shape, spectrum, and size of the object. The shapes are
 * represented by {@link gov.fnal.eag.sim.catalog.Morphology} objects, and the 
 * spectra by {@link gov.fnal.eag.sim.catalog.SED} objects.
 * {@link gov.fnal.eag.sim.catalog.AstronomicalFilter} objects can be used to derive
 * photometric parameters for an object.
 */

package gov.fnal.eag.sim.catalog;