package gov.fnal.eag.sim.extractor;

import gov.fnal.eag.util.astronomy.SimpleFunction;

/**
 * returns the expected sigma given a true sigma
 * @author stoughto
 *
 */
public class SigmaExpected extends SimpleFunction {

	double radius;
	/**
	 * @param radiusIn radius of the circular aperture that contains the flux
	 */
	public SigmaExpected(double radiusIn) {
		radius = radiusIn;
	}
	/**
	 * @see gov.fnal.eag.util.astronomy.SimpleFunction#f(double)
	 */
	@Override
	public double f(double sigmaTrue) {
		return Moment.sigmaExpected(sigmaTrue, radius);
	}

}
