package gov.fnal.eag.sim.extractor;

import gov.fnal.eag.util.astronomy.SimpleFunction;

/**
 * returns the expected sigma windowed given a true sigma
 * @author stoughto
 *
 */
public class SigmaWindowedExpected extends SimpleFunction {

	double radius;
	double sigmaWindow;
	/**
	 * @param radiusIn radius of the circular aperture that contains the flux
	 * @param sigmaWindowIn sigma of the window function
	 */
	public SigmaWindowedExpected(double radiusIn, double sigmaWindowIn) {
		radius = radiusIn;
		sigmaWindow = sigmaWindowIn;
	}
	/**
	 * @see gov.fnal.eag.util.astronomy.SimpleFunction#f(double)
	 */
	@Override
	public double f(double sigmaTrue) {
		return Moment.sigmaExpectedWindowed(radius, sigmaWindow, sigmaTrue);
	}

}
