
package gov.fnal.eag.sim.pixel;

/**
 * describes the background light from atmospheric, zodiacal, and stray light in the pixel reference frame
 */
public interface BackgroundLight {
	/**
	 * get the number of photons in a pixel
	 * @param row row pixel position
	 * @param col column pixel position
	 * @return the mean number of photons from background light per pixel
	 */
	double getLightInPixel(double row, double col);
}
