package gov.fnal.eag.sim.pixel;

/**
 * simply digitize 
 * @author stoughto
 *
 */
public class LookupTableNBits extends LookupTable {

	private int nBits, maxValue;
	
	/**
	 * digitizes with no scaling or offset
	 * @param nBits number of bits to use
	 */
	public LookupTableNBits(int nBits) {
		this.nBits = nBits;
		maxValue = (int) Math.pow(2, nBits) - 1;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.LookupTable#compress(double)
	 */
	@Override
	public int compress(double electrons) {
		int retval = (int) Math.floor(electrons);
		retval = Math.max(retval, 0);
		retval = Math.min(retval, maxValue);
		return retval;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.LookupTable#getNBits()
	 */
	@Override
	public int getNBits() {
		return nBits;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.LookupTable#restore(int)
	 */
	@Override
	public double restore(int compressed) {
		return compressed;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.LookupTable#nValues(int)
	 */
	@Override
	public int nValues(int compressed) {
		throw new UnsupportedOperationException();
	}
	

}
