package gov.fnal.eag.sim.pixel;

import gov.fnal.eag.sim.repository.image.FitsDataFormat;
import gov.fnal.eag.sim.repository.image.ImageRepository;

/**
 * contains a main method to run the capacitive coupling code
 * @author stoughto
 *
 */
public class NIR {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		if (args.length != 4) {
			System.out.println("Apply NIR capacitive coupling");
			String name = NIR.class.getName();
			System.out.println("Usage:  "+name+" ratio deltaQThreshold inputFileName outputFileName");
			System.out.println(" where ratio = inter-pixel/readout capacitance (e.g. 0.01)");
			System.out.println("   the algorithm iterates until the maximum change in Q in an iteration is less than deltaQThreshold (e.g. 1E-5)");
			return;
		}
		String inFileName = args[2];
		String outFileName = args[3];
		if (inFileName.equals(outFileName)) {
			System.out.println("Error:  inFileName and outFileName are the same");
			return;
		}
		double ratio = Double.parseDouble(args[0]);
		double deltaQThreshold = Double.parseDouble(args[1]);
		
		PixeledImage pi = ImageRepository.readPixeledImage(inFileName);
		pi.ipcApply(ratio, deltaQThreshold);
		ImageRepository.write(outFileName, pi, FitsDataFormat.FLOAT, true);
	}

}
