package gov.fnal.eag.sim.pixel;

import gov.fnal.eag.wcs.Coordinate;

import java.awt.geom.Point2D.Double;

/**
 * keeps track of analytic PSFs
 * @author stoughto
 *
 */
public class PSFAnalytic implements PSF {

	/**
	 * @author stoughto
	 *
	 */
	public enum Type {
		/**
		 * a gaussian
		 */
		GAUSSIAN, 
		/**
		 * square pixel response function
		 */
		BOX
	}
	private double scaleArcsec;
	
	Coordinate coordinate = new Coordinate(0,0);

	/**
	 * @param type
	 * @param scaleArcsec
	 */
	public PSFAnalytic(Type type, double scaleArcsec) {
		//this.type = type;
		this.scaleArcsec = scaleArcsec;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#convolve(gov.fnal.eag.sim.pixel.PixeledImage)
	 */
	public void convolve(PixeledImage pixeledImage) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#convolve(gov.fnal.eag.sim.pixel.PixeledImage, gov.fnal.eag.sim.pixel.BackgroundLight)
	 */
	public void convolve(PixeledImage pixeledImage,
			BackgroundLight backgroundLight) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#convolve(gov.fnal.eag.sim.pixel.PSF)
	 */
	public void convolve(PSF psf) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#getEigenvalues()
	 */
	public double[][] getEigenvalues() {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#getKernel()
	 */
	public PixeledImage getKernel() {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#getScale()
	 */
	public double getScale() {
		return scaleArcsec;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#intensity(java.awt.geom.Point2D.Double)
	 */
	public double intensity(Double location) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#multiplyScale(double)
	 */
	public void multiplyScale(double factor) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#ncol()
	 */
	public int ncol() {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#nextPoint()
	 */
	public Double nextPoint() {
		throw new UnsupportedOperationException();
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#nrow()
	 */
	public int nrow() {
		throw new UnsupportedOperationException();
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSF#getXyfpMeters()
	 */
	public Coordinate getXyfpMeters() {
		return coordinate;
	}

}
