package gov.fnal.eag.sim.pixel;

import gov.fnal.eag.wcs.Coordinate;
import gov.fnal.eag.wcs.SphericalCoordinate;


/**
 * always return a null PSF
 */
public class PSFFactoryNull implements PSFFactory {
	/**
	 * the psf for this factory
	 */
	private static PSF psf;
	
	/**
	 * construct a factory that always returns null
	 */
	public PSFFactoryNull() {
		psf = null;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.sim.pixel.DetectorObject)
	 */
	public PSF getPsf(DetectorObject detectorObject) {
		// You can get row, col from detectorObject if you need them.
		return psf;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.wcs.Coordinate)
	 */
	public PSF getPsf(Coordinate coordinate) {
		return psf;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#convolve(gov.fnal.eag.sim.pixel.PixeledImage)
	 */
	public void convolve(PixeledImage pixeledImage) {
			return;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#convolve(gov.fnal.eag.sim.pixel.PixeledImage, gov.fnal.eag.sim.pixel.BackgroundLight)
	 */
	public void convolve(PixeledImage pixeledImage, BackgroundLight backgroundLight) {
		return;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#moveTelescope(gov.fnal.eag.wcs.SphericalCoordinate)
	 */
	public void moveTelescope(SphericalCoordinate sc) {
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.wcs.SphericalCoordinate)
	 */
	public PSF getPsf(SphericalCoordinate sc) {
		return psf;
	}

}
