/*
 * Created on Apr 26, 2005
 *
 * @author stoughto
 */
package gov.fnal.eag.sim.pixel;

import gov.fnal.eag.wcs.Coordinate;
import gov.fnal.eag.wcs.SphericalCoordinate;

import java.util.Hashtable;

/**
 * PSF is defined for each object
 * @author stoughto
 *
 */
public class PSFFactoryPerObject implements PSFFactory {
	private Hashtable<DetectorObject, PSF> psfHashtable = new Hashtable<DetectorObject, PSF>();

	/**
	 * @param psfHashtable containing one PSF for each object
	 */
	public PSFFactoryPerObject(Hashtable<DetectorObject, PSF>  psfHashtable) {
		this.psfHashtable = psfHashtable;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.sim.pixel.DetectorObject)
	 */
	public PSF getPsf(DetectorObject detectorObject) {
		return psfHashtable.get(detectorObject);
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#convolve(gov.fnal.eag.sim.pixel.PixeledImage)
	 */
	public void convolve(PixeledImage pixeledImage) {
		// TODO Auto-generated method stub
		return;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#convolve(gov.fnal.eag.sim.pixel.PixeledImage, gov.fnal.eag.sim.pixel.BackgroundLight)
	 */
	public void convolve(PixeledImage bright, BackgroundLight backgroundLight) {
		// TODO Auto-generated method stub
		return;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.wcs.Coordinate)
	 */
	public PSF getPsf(Coordinate coordinate) {
		throw new Error("need to implement this");
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#moveTelescope(gov.fnal.eag.wcs.SphericalCoordinate)
	 */
	public void moveTelescope(SphericalCoordinate sc) {
		// TODO Auto-generated method stub
		
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PSFFactory#getPsf(gov.fnal.eag.wcs.SphericalCoordinate)
	 * @throws UnsupportedOperationException
	 */
	public PSF getPsf(SphericalCoordinate sc) {
		throw new UnsupportedOperationException();
	}

}
