package gov.fnal.eag.sim.pixel;

import java.io.PrintStream;

/**
 * transform an input value to an output value
 */
public interface PixelValueTransformation {
    
	/**
	 * transform the pixel value at the given position
	 * @param x input value
	 * @param row row position in pixel space
	 * @param col column position in pixel space
	 * @return transformed value
	 */
	public double transform(double x, double row, double col);
	
	/**
	 * get the name of this transformation
	 * @return the name
	 */
	public String getName();

	/**
	 * report what this transformation does
	 * @param ps
	 */
	public void report(PrintStream ps);
}
