package gov.fnal.eag.sim.pixel;

import java.io.PrintStream;

/**
 * adds the constant value
 */
public class PixelValueTransformationAddConstant implements PixelValueTransformation {
	/**
	 * a useful name for this transformation
	 */
	String name = "unknown";
	/**
	 * constant to add
	 */
	private double constant;
	
	/**
	 * constructor with the constant defined
	 * @param constant the value to add in the transformation
	 * @param name an information name for this transformation
	 */
	public PixelValueTransformationAddConstant(double  constant, String name) {
		this.constant = constant;
		this.name = name;
	}
	/**
	 * a no-op transformation, add zero
	 */
	public PixelValueTransformationAddConstant() {
		this(0.0, "identity");
	}
	/**
	 * adds the constant to the input value
	 * @param x input value
	 * @return transformed value
	 */
	public double transform(double x) {
		return x+constant;
	}


	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#transform(double, double, double)
	 */
	public double transform(double x, double row, double col) {
		return transform(x);
	}
	
	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#getName()
	 */
	public String getName() {
		return name;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#report(java.io.PrintStream)
	 */
	public void report(PrintStream ps) {
		ps.println("      name="+name+"  add constant="+constant);
	}

}
