package gov.fnal.eag.sim.pixel;

import java.io.PrintStream;

/**
 * adds the pixeledImage value
 */
public class PixelValueTransformationAddPixeledImage implements PixelValueTransformation {
	/**
	 * a useful name for this transformation
	 */
	String name = "unknown";
	/**
	 * pixeledImage to add
	 */
	private PixeledImage pixeledImage = null;
	
	/**
	 * constructor with the pixeledImage defined
	 * @param pixeledImage the value to add in the transformation
     * @param name name of this transformation
	 */
	public PixelValueTransformationAddPixeledImage(PixeledImage pixeledImage, String name) {
		this.pixeledImage = pixeledImage;
		this.name = name;
	}
	/**
	 * create a no-op transformation that adds a null image
	 */
	public PixelValueTransformationAddPixeledImage() {
		this(null, "identity");
	}


	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#transform(double, double, double)
	 */
	public double transform(double x, double row, double col) {
	   if (pixeledImage == null) {
           return x;
       } 
           return x + pixeledImage.getByRowCol(row,col);
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#getName()
	 */
	public String getName() {
		return name;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#report(java.io.PrintStream)
	 */
	public void report(PrintStream ps) {
		ps.println("      name="+name+"  add pixeledImage="+pixeledImage);
	}

}
