package gov.fnal.eag.sim.pixel;

import java.io.PrintStream;

/**
 * demonstrates how to use the static pixeledImage cross to access other pixels
 * @author stoughto
 *
 */
public class PixelValueTransformationCrosstalkShift extends PixelValueTransformationCrosstalk {

    /**
     * delta row to shift
     */
    private int dRow = 0;
    /**
     * delta column to shift
     */
    private int dCol = 0;
    /**
     * name of this transformation
     */
    private String name = "unnamed";

    /**
     * fully-specified constructor
     * @param dRow number of rows to shift
     * @param dCol number of columns to shift
     * @param name name of the transformation
     */
    public PixelValueTransformationCrosstalkShift(int dRow, int dCol, String name) {
        this.dRow = dRow;
        this.dCol = dCol;
        this.name = name;
    }

    /**
     * ignore the input value and return the value of the cross PixeledImage, offset by dRow and dCol
     * @param x input value, ignored
     * @param row pixel position
     * @param col pixel position
     * @return transformed value
     */
    public double transform(double x, double row, double col) {
        return cross.getByRowCol(row+dRow,col+dCol);
    }

    /**
     * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#getName()
     */
    public String getName() {
        return name;
    }


    /**
     * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#report(java.io.PrintStream)
     */
    public void report(PrintStream ps) {
        // TODO Auto-generated method stub

    }

}
