package gov.fnal.eag.sim.pixel;

import java.io.PrintStream;

/**
 * adds the pixeledImage value
 */
public class PixelValueTransformationMultiplyPixeledImage implements PixelValueTransformation {
	/**
	 * a useful name for this transformation
	 */
	String name = "unknown";
	/**
	 * pixeledImage to multiply
	 */
	private PixeledImage pixeledImage = null;	
	/**
	 * constructor with the pixeledImage defined
	 * @param pixeledImage the value to add in the transformation
     * @param name name of this transformation
	 */
	public PixelValueTransformationMultiplyPixeledImage(PixeledImage pixeledImage, String name) {
		this.pixeledImage = pixeledImage;
		this.name = name;
	}
	/**
	 * create a no-op version of this transform
	 */
	public PixelValueTransformationMultiplyPixeledImage() {
		this(null, "identity");
	}

	/**
	 * adds pixeledImage
	 * @param x input value
	 * @param row row position
	 * @param col column position
	 * @return transformed value
	 */
	public double transform(double x, double row, double col) {
	   if (pixeledImage == null) {
           return x;
       }
	   return x * pixeledImage.getByRowCol(row,col);
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#getName()
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see gov.fnal.eag.sim.pixel.PixelValueTransformation#report(java.io.PrintStream)
	 */
	public void report(PrintStream ps) {
		ps.println("      name="+name+"  multiply pixeledImage="+pixeledImage);
	}

}
