package gov.fnal.eag.sim.pixel;



import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

/**
 * handles drawing a line on a plot
 * @author stoughto
 *
 */
public class SimpleLine extends ImageGlyph {
	
	private static final Color DEFAULT_COLOR = Color.cyan;
	private int row0, col0, row1, col1;
	/**
	 * @param row0
	 * @param col0
	 * @param row1
	 * @param col1
	 */
	public SimpleLine(int row0, int col0, int row1, int col1) {
		this(row0, col0, row1, col1, DEFAULT_COLOR);
	}
	
	/**
	 * @param row0
	 * @param col0
	 * @param row1
	 * @param col1
	 * @param color
	 */
	public SimpleLine(int row0, int col0, int row1, int col1, Color color) {
		this.row0 = row0;
		this.col0 = col0;
		this.row1 = row1;
		this.col1 = col1;
		setFgColor(color);
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.ImageGlyph#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D g2d) {
		g2d.setColor(getFgColor());
		g2d.draw(new Line2D.Double(col0, row0, col1, row1));
	}
	
}
