package gov.fnal.eag.sim.pixel;



import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

/**
 * marks an X inside a pixel
 * @author stoughto
 *
 */
public class SimplePixelMark extends ImageGlyph {
	
	private static final Color DEFAULT_COLOR = Color.green;
	private int row,col;
	/**
	 * @param row
	 * @param col
	 */
	public SimplePixelMark(int row, int col) {
		this.row = row;
		this.col = col;
		setFgColor(DEFAULT_COLOR);
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.ImageGlyph#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D g2d) {
		g2d.setColor(getFgColor());
		g2d.draw(new Line2D.Double(col, row, col+1, row+1));
		g2d.draw(new Line2D.Double(col, row+1, col+1, row));
	}
	
}
