package gov.fnal.eag.sim.pixel;


import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;

/**
 * handles putting text in plots
 * @author stoughto
 *
 */
public class SimpleText extends ImageGlyph {
	private String text;
	private Font font;
	/**
	 * @param text
	 * @param row
	 * @param col
	 * @param font
	 */
	public SimpleText(String text, double row, double col, Font font) {
		this.text = text;
		setLocation(new Point2D.Double(col,row));
		this.font = font;
	}
	/**
	 * @see gov.fnal.eag.sim.pixel.ImageGlyph#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D g2d) {
		if (font != null) {
			g2d.setFont(font);
		}
		AffineTransform original = g2d.getTransform();
		Point2D tmp = original.transform(getLocation(), null);
		g2d.setTransform(new AffineTransform());
		g2d.setColor(getFgColor());
		g2d.drawString(text, (float) tmp.getX(), (float) tmp.getY());
		g2d.setTransform(original);
	}	
}
