package gov.fnal.eag.sim.pixel;

/**
 * squares of pixels
 */
public class Squares {
	/**
	 * the largest radius to consider
	 */
	public static int SQUARES_MAX_RADIUS = 200;

	/**
	 * the pixels of the square, indexed as [rowcol][iSquare][iPixel] where
	 * rowcol=0 for row, 1 for col, iSquare=0,SQUARES_MAX_RADIUS, iPixel
	 */
	public static int[][][] squares;

	/**
	 * the number of pixels per square
	 */
	public static int[] nPixelsPerSquare;

	/**
	 * return pointer to the squares
	 * 
	 * @return the squares
	 */
	static {
		int maxRadius = SQUARES_MAX_RADIUS;
		squares = new int[2][maxRadius][8 * maxRadius];
		nPixelsPerSquare = new int[maxRadius];
		for (int iSquare = 0; iSquare < maxRadius; iSquare++) {
			int nPixel = 0;
			for (int row = -iSquare; row <= iSquare; row++) {
				for (int col = -iSquare; col <= iSquare; col++) {
					if (Math.abs(row) == iSquare
							|| Math.abs(col) == iSquare) {
						squares[0][iSquare][nPixel] = col;
						squares[1][iSquare][nPixel] = row;
						nPixel++;
					}
				}
			}
			nPixelsPerSquare[iSquare] = nPixel;
		}
	}
	/**
	 * @return the squares array
	 */
	public static int[][][] getSquares() {
		return squares;
	}

	/**
	 * return pointer to the number of pixels per square
	 * 
	 * @return nPixelsPerSquare
	 */
	public static int[] getNPixelsPerSquare() {
		return nPixelsPerSquare;
	}
}