package gov.fnal.eag.sim.pixel.test;


import gov.fnal.eag.shapelets.functions.Decompose;
import gov.fnal.eag.sim.pixel.DetectorObjectProfile;
import gov.fnal.eag.sim.pixel.DetectorObjectSurfaceBrightness;
import gov.fnal.eag.sim.pixel.PixeledImage;
import gov.fnal.eag.sim.pixel.Profiles;
import gov.fnal.eag.sim.repository.image.ImageRepository;
import junit.framework.TestCase;

/**
 * demonstrate how to rotate shapelet objects and write examples to rotateDemo.fit
 * @author stoughto
 *
 */
public class RotateDemo extends TestCase {
	/**
	 * rotate a shapelet object
	 * @throws Exception
	 */
	public static void testRotate() throws Exception {
		int size=100;
		double scale = 6.0;
		int nGrid = 5;
		DetectorObjectProfile dop = new DetectorObjectProfile(size/2, size/2, 1000.0, "gauss", scale, 0.5, 0.0, new Profiles() );
		int nper = 4;
		double[][] pixels = new double[100][100];
		for (int r=0; r<size; r++) {
			for (int c=0; c<size; c++) {
				pixels[r][c] = dop.getFluxByPix(r, c, nGrid);
			}
		}
		Decompose decompose = new Decompose(pixels, size/2, size/2, scale);
		int nMax = 15;
		double[] ev1 = decompose.getFnnV(nMax);
		
		DetectorObjectSurfaceBrightness dosb = new DetectorObjectSurfaceBrightness(size/2, size/2, 1000.0, ev1, scale);
		
		PixeledImage pi = new PixeledImage(nper*size, nper*size);
		for (int i=0; i<nper; i++) {
			for (int j=0; j<nper; j++) {
				//System.out.println(" i="+i+" j="+j);
				for (int r=0; r<size; r++) {
					for (int c=0; c<size; c++) {
						pi.setByRowCol(r+i*size, c+j*size, dosb.getFluxByPix(r, c));
					}
				}				
				dosb.rotate(10.0);
			}
		}
		ImageRepository ir = new ImageRepository();
		ir.put("rotateDemo.fit", pi, true);
	}
}
