package gov.fnal.eag.sim.pixel.wavelet;

/**
 * @author mcginnis
 *
 */
public class NR 
{
	/**
	 * @param a
	 * @param n
	 * @param b
	 * @param m
	 * @return
	 */
	public static boolean 	Guassj( double[][] a, int n, double[][] b, int m)
	{
		double	big;
		double	dum;
		double	pivinv;
		int[]	ipiv = null;
		int[]	indxr = null;
		int[]	indxc = null;
		int		i;
		int		j;
		int		k;
		int		l;
		int		ll;
		int		irow = 0;
		int		icol = 0;
		boolean	istatus;
		double	dswap;
		
		indxc = new int[n + 1];
		indxr = new int[n + 1];
		ipiv = new int[n + 1];

		istatus = true;
		for ( j = 1; j <= n; j++ ) ipiv[j] = 0;
		for ( i = 1; i <= n; i++ )
		{
			big = 0.0;
			for ( j = 1; j <= n; j++ )
			{
				if ( ipiv[j] != 1 )
				{
					for ( k = 1; k <= n; k++ )
					{
						if ( ipiv[k] == 0 )
						{
							if ( Math.abs( a[j][k] ) >= big )
							{
								big = Math.abs( a[j][k] );
								irow = j;
								icol = k;
							}
						}
						else if ( ipiv[k] > 1 )
						{
							istatus = false;
							return istatus;
//							printf("Singular Matrix-1 in guassj. Now exiting to system\n");
//							exit(1);
						}
					}
				}
			}
			ipiv[icol] = ipiv[icol] + 1;
			if ( irow != icol )
			{
				for ( l = 1; l <= n; l++ ) 
				{
					dswap = a[irow][l];
					a[irow][l] = a[icol][l];
					a[icol][l] = dswap;
				}
				for ( l = 1; l <= m; l++ )
				{
					dswap = b[irow][l];
					b[irow][l] = b[icol][l];
					b[icol][l] = dswap;
				}
			}
			indxr[i] = irow;
			indxc[i] = icol;
			if ( a[icol][icol] == 0.0 )
			{
				istatus = false;
				return false;
//				printf("Singular Matrix-2 in guassj. Now exiting to system\n");
//				exit(1);
			}
			pivinv = 1.0 / a[icol][icol];
			a[icol][icol] = 1.0;
			for ( l = 1; l <= n; l++ ) a[icol][l] *= pivinv;
			for ( l = 1; l <= m; l++ ) b[icol][l] *= pivinv;
			for( ll = 1; ll <= n; ll++ )
			{
				if ( ll != icol )
				{
					dum = a[ll][icol];
					a[ll][icol] = 0.0;
					for ( l = 1; l <= n; l++ ) a[ll][l] -= a[icol][l] * dum;
					for ( l = 1; l <= m; l++ ) b[ll][l] -= b[icol][l] * dum;
				}
			}
		}
		for ( l = n; l >= 1; l-- )
		{
			if (indxr[l] != indxc[l] )
			{
				for ( k = 1; k <= n; k++ ) 
				{
					dswap = a[k][indxr[l]];
					a[k][indxr[l]] = a[k][indxc[l]];
					a[k][indxc[l]] = dswap;
				}
			}
		}
		ipiv = null;
		indxr = null;
		indxc = null;
		return istatus;
	}
	/**
	 * @param k
	 * @param n
	 * @param arr
	 * @return
	 */
	public static double select(int k, int n, double arr[])
	{
		int i,ir,j,l,mid;
		double a;
		double dswap;

		l=1;
		ir=n;
		for (;;) 
		{
			if (ir <= l+1) 
			{
				if (ir == l+1 && arr[ir] < arr[l]) 
				{
					dswap = arr[l];
					arr[l] = arr[ir];
					arr[ir] = dswap;
				}
				return arr[k];
			} 
			else 
			{
				mid=(l+ir) >> 1;
				dswap = arr[mid];
				arr[mid] = arr[l+1];
				arr[l+1] = dswap;
				if (arr[l] > arr[ir]) 
				{
					dswap = arr[l];
					arr[l] = arr[ir];
					arr[ir] = dswap;
				}
				if (arr[l+1] > arr[ir]) 
				{
					dswap = arr[l+1];
					arr[l+1] = arr[ir];
					arr[ir] = dswap;
				}
				if (arr[l] > arr[l+1]) 
				{
					dswap = arr[l];
					arr[l] = arr[l+1];
					arr[l+1] = dswap;
				}
				i=l+1;
				j=ir;
				a=arr[l+1];
				for (;;) 
				{
					do i++; while (arr[i] < a);
					do j--; while (arr[j] > a);
					if (j < i) break;
					dswap = arr[i];
					arr[i] = arr[j];
					arr[j] = dswap;
				}
				arr[l+1]=arr[j];
				arr[j]=a;
				if (j >= k) ir=j-1;
				if (j <= k) l=i;
			}
		}
	}
	/**
	 * @param n
	 * @param arr
	 */
	public static void sort(int n, double arr[])
	{
		int i,ir=n,j,k,l=1;
		int[] istack = null;
		int jstack=0;
		double a;
		int 	NSTACK = 50;
		int		M = 7;
		double	dswap;

		istack = new int[NSTACK + 1];
		for (;;) 
		{
			if (ir-l < M) 
			{
				for (j=l+1;j<=ir;j++) 
				{
					a=arr[j];
					for (i=j-1;i>=l;i--) 
					{
						if (arr[i] <= a) break;
						arr[i+1]=arr[i];
					}
					arr[i+1]=a;
				}
				if (jstack == 0) break;
				ir=istack[jstack--];
				l=istack[jstack--];
			} 
			else 
			{
				k=(l+ir) >> 1;
				dswap = arr[k];
				arr[k] = arr[l+1];
				arr[l+1] = dswap;
				if (arr[l] > arr[ir]) 
				{
					dswap = arr[l];
					arr[l] = arr[ir];
					arr[ir] = dswap;
				}
				if (arr[l+1] > arr[ir]) 
				{
					dswap = arr[l+1];
					arr[l+1] = arr[ir];
					arr[ir] = dswap;
				}
				if (arr[l] > arr[l+1]) 
				{
					dswap = arr[l];
					arr[l] = arr[l+1];
					arr[l+1] = dswap;
				}
				i=l+1;
				j=ir;
				a=arr[l+1];
				for (;;) 
				{
					do i++; while (arr[i] < a);
					do j--; while (arr[j] > a);
					if (j < i) break;
					dswap = arr[i];
					arr[i] = arr[j];
					arr[j] = dswap;
				}
				arr[l+1]=arr[j];
				arr[j]=a;
				jstack += 2;
				if (ir-i+1 >= j-l) 
				{
					istack[jstack]=ir;
					istack[jstack-1]=i;
					ir=j-1;
				} 
				else 
				{
					istack[jstack]=j-1;
					istack[jstack-1]=l;
					l=i;
				}
			}
		}
		istack = null;
	}
}
