package gov.fnal.eag.sim.repository.image;

import gov.fnal.eag.util.yanny.Table;

import java.io.IOException;

import uk.ac.starlink.fits.FitsTableBuilder;
import uk.ac.starlink.table.StarTable;
import uk.ac.starlink.table.StoragePolicy;
import uk.ac.starlink.util.DataSource;
import uk.ac.starlink.util.FileDataSource;

/**
 * demonstrates how to read a "large" file into a StarTable
 * @author kuropat
 *
 */
public class ReadBigFile {

	/**
	 * @throws IOException 
	 */
	public ReadBigFile() throws IOException {
		String fileName = "lightconeBOX_003_5.fit";
		//InputStream inputStream = new FileInputStream(fileName);
		FitsTableBuilder tb = new FitsTableBuilder();
		DataSource dataSource = new FileDataSource(fileName);
		boolean wantRandom = false;
		StoragePolicy sp = StoragePolicy.PREFER_DISK;
		StarTable st = tb.makeStarTable(dataSource, wantRandom, sp);
		System.out.println("st:  columns="+st.getColumnCount()+" rows="+st.getRowCount());
		int xcIndex = Table.getIndexByName(st, "xc");
		int idIndex = Table.getIndexByName(st, "id");
		for (int i=0; i<st.getRowCount(); i++) {
			Object[] row = st.getRow(i);
			long id = (Long) row[idIndex];
			double xc = (Float) row[xcIndex];
			if (i%100 == 0) {
				System.out.println("i="+i+"/"+st.getRowCount()+" id="+id+" xc="+xc);
			}
		}		
	}
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		new ReadBigFile();
	}

}
