package gov.fnal.eag.sim.repository.image.test;

import gov.fnal.eag.sim.pixel.PixeledImage;
import gov.fnal.eag.sim.repository.image.ImageRepository;
import gov.fnal.eag.util.misc.CommandLine;
import junit.framework.TestCase;
import nom.tam.fits.Fits;
import nom.tam.util.BufferedFile;

/**
 * demonstrates how to write PixeledImages to .fits files and runs fitsverify on the resulting file
 * @author stoughto
 *
 */
public class MultiImage extends TestCase {

	/**
	 * 
	 * @throws Exception
	 */
	public void testTwoPIUsingFits() throws Exception {

		Fits fits = new Fits();

		PixeledImage pi1 = new PixeledImage(1,1);
		double value1 = 1.234;
		pi1.setScalar(value1);
		fits.addHDU(Fits.makeHDU(pi1.getPix()));

		PixeledImage pi2 = new PixeledImage(2,2);
		double value2 = 5.432;
		pi2.setScalar(value2);

		fits.addHDU(Fits.makeHDU(pi2.getPix()));

		String fileName = "testTwoPIUsingFits.fits";
		BufferedFile bf = new BufferedFile(fileName, "rw");
		fits.write(bf);
		bf.close();

		int valid = CommandLine.run("fitsverify "+fileName);
		assertEquals(0, valid);
		
		PixeledImage.verboseEquals = true;
		{
			ImageRepository ir = new ImageRepository(".");
			PixeledImage pi = ir.getPixeledImage(fileName, 0);
			assertTrue(pi1.equals(pi));
		}
		{
			ImageRepository ir = new ImageRepository(".");
			PixeledImage pi = ir.getPixeledImage(fileName,1);
			assertTrue(pi2.equals(pi));
		}
		
	}
}
