package gov.fnal.eag.sim.utils;

import gov.fnal.eag.sim.repository.image.ImageRepository;
import uk.ac.starlink.table.StarTable;
import uk.ac.starlink.table.formats.CsvStarTable;
import uk.ac.starlink.util.DataSource;

/**
 * convert a CSV file to a FITS binary table
 * @author stoughto
 *
 */
public class CsvToFits {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		run(args[0]);
	}

	/**
	 * 
	 * @param baseFileName file to convert, without the .csv suffix
	 * @throws Exception
	 */
	public static void run(String baseFileName) throws Exception {
		String fileName = baseFileName+".csv";
		DataSource ds = DataSource.makeDataSource(fileName);
		StarTable st = new CsvStarTable(ds);
		ImageRepository.write(baseFileName+".fit", st, true);
	}
}
