package gov.fnal.eag.sim.utils;

import gov.fnal.eag.util.densityEstimate.Polynomial2D;
import gov.fnal.eag.wcs.Coordinate;
import gov.fnal.eag.wcs.TransformPlanar;

/**
 * transform x,y points in a plane with a polynomial in each direction
 * @author stoughto
 *
 */
public class TransformPoly implements TransformPlanar {
	Polynomial2D xPoly, yPoly;
	/**
	 * @param xPoly
	 * @param yPoly
	 */
	public TransformPoly(Polynomial2D xPoly, Polynomial2D yPoly) {
		this.xPoly = xPoly;
		this.yPoly = yPoly;
	}
	/**
	 * @see gov.fnal.eag.wcs.TransformPlanar#forwardInPlace(gov.fnal.eag.wcs.Coordinate)
	 */
	public void forwardInPlace(Coordinate coordinate) {
		double x = coordinate.getX();
		double y = coordinate.getY();
		coordinate.setX(xPoly.value(x, y));
		coordinate.setY(yPoly.value(x, y));		
	}
	/**
	 * @see gov.fnal.eag.wcs.TransformPlanar#getDescription()
	 */
	public String getDescription() {
		String retval = String.format("order=(%d,%d)",xPoly.getOrder(), yPoly.getOrder());
		return retval;
	}	
	
	/**
	 * @return the x transformation
	 */
	public Polynomial2D getXPoly() {
		return xPoly;
	}
	/**
	 * @return the y transformation
	 */
	public Polynomial2D getYPoly() {
		return yPoly;
	}
}
