package gov.fnal.eag.sim.utils;

import gov.fnal.eag.util.densityEstimate.Polynomial1D;
import gov.fnal.eag.wcs.Coordinate;
import gov.fnal.eag.wcs.TransformPlanar;

/**
 * transforms the x and y axes with the same Polynomial1D
 * @author stoughto
 *
 */
public class TransformPolyRadial implements TransformPlanar {

	Polynomial1D poly;
	
	/**
	 * @param poly
	 */
	public TransformPolyRadial(Polynomial1D poly) {
		this.poly = poly;
	}
	/**
	 * @see gov.fnal.eag.wcs.TransformPlanar#forwardInPlace(gov.fnal.eag.wcs.Coordinate)
	 */
	public void forwardInPlace(Coordinate coordinate) {
		double x = coordinate.getX();
		double y = coordinate.getY();
		coordinate.setX(poly.valueAt(x));
		coordinate.setY(poly.valueAt(y));		
	}

	/**
	 * @see gov.fnal.eag.wcs.TransformPlanar#getDescription()
	 */
	public String getDescription() {
		String retval = String.format("order=(%d)",poly.getOrder());
		return retval;
	}
	/**
	 * @return the polynomial that defines this transform
	 */
	public Polynomial1D getPoly() {
		return poly;
	}

}
