package gov.fnal.eag.util.astronomy;


/**
 * @author dcharms
 *
 */


public class NormalDistribution extends SimpleFunction {

	private double mean;
	private double sigma;
	
	/**
	 * Create a Gauss distribution
	 * @param mean mean of normal distribution
	 * @param sigma sigma of normal distribution
	 */
	public NormalDistribution(double mean, double sigma) {
		this.mean = mean;
		this.sigma = sigma;
	}

	/**
	 * calculate the value of function at given x value
	 * @param x x value for function
	 * @return function value for given x
	 */
	@Override
	public double f(double x) {
		double value = (1/(Math.sqrt(2*Math.PI)*sigma))*Math.exp(-(((x-mean)*(x-mean))/(2*sigma*sigma)));
		return value;
	}

}
