package gov.fnal.eag.util.astronomy;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * static methods to do simple date formatting
 * @author stoughto
 *
 */
public class TimeFormat {
	/**
	 * the number of milliseconds in a day
	 */
	public static double millisecondsPerDay = 1000*60*60*24;
	/**
	 * the MJD when java time is zero
	 */
	public static double javaEpochMJD = 40587.0;
	/**
	 * get the MJD
	 * @param date for this date
	 * @return the MJD
	 */
	public static double mjd(Date date) {
		return (date.getTime()/millisecondsPerDay)+javaEpochMJD;
	}
	
	/**
	 * @param date
	 * @return date formated at yyyy-mm-dd
	 */
	public static String yyyymmdd(Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
       	String dateObs = sdf.format(date);
       	return dateObs;
	}
}
