package gov.fnal.eag.util.densityEstimate;

/**
 * 
 * @author stoughto
 *
 */
public class FitFunctionDoubleExponential extends FitFunction {
	
	/**
	 *  default constructor that defines the names
	 */
	public FitFunctionDoubleExponential() {
		name = "doubleExponential";
		parameterNames = new String[] {"norm1","tau1","norm2","tau2"};
		parameters = new double[4];
		errors = new double[4];
	}
	

	/**
	 * @see gov.fnal.eag.util.densityEstimate.FitFunction#valueAt(double)
	 */
	@Override
	public double valueAt(double x) {
		double norm1 = parameters[0];
		double tau1  = parameters[1];
		double norm2 = parameters[2];
		double tau2  = parameters[3];
		double value = norm1*Math.exp(-x/tau1) + norm2*Math.exp(-x/tau2);
		return value;
	}

}
