package gov.fnal.eag.util.densityEstimate;

/**
 * 
 * @author stoughto
 *
 */
public class FitFunctionPolynomial extends FitFunction {
	
	/**
	 *  default constructor that defines the names
	 * @param order 0 for constant, 1 for linear, 2 for quadratic, and so on
	 */
	public FitFunctionPolynomial(int order) {
		if (order < 0) {
			throw new IllegalArgumentException("order must be >=0 but order="+order);
		}		
		name = "polynomial order "+order;
		parameterNames = new String[order+1];
		for (int i=0; i<=order; i++) {
			parameterNames[i] = "a_"+i;
		}
		parameters = new double[order+1];
		errors = new double[order+1];
	}
	

	/**
	 * @see gov.fnal.eag.util.densityEstimate.FitFunction#valueAt(double)
	 */
	@Override
	public double valueAt(double x) {
		double retval = parameters[0];
		double xn = 1;
		for (int i=1; i<parameters.length; i++) {
			xn *= x;
			retval += parameters[i]*xn;
		}
		return retval;
	}

}
