package gov.fnal.eag.util.densityEstimate.examples;

import gov.fnal.eag.util.misc.StringUtil;

import java.io.File;
import java.io.IOException;
import java.util.Random;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.statistics.HistogramDataset;
import org.jfree.data.statistics.HistogramType;

/**
 * Using just jfreechart to make a histogram
 * 
 * This isn't an example of using the code actually contained
 * in the gov.fnal.eag.util.densityEstimate, just a demostration
 * of using basic jfreechart to make a histogram.
 * 
 * */
public class HistogramExample {
	/**
	 * @param args ignored
	 */
	public static void main(String[] args) {

		// Create array that contains 100 random values between 0 and 1
		double[] value = new double[100];
		Random generator = new Random();
		for (int i=0; i < 100; i++) {
			value[i] = generator.nextDouble();
		}
		
		double min = 0.0; // the bottom of the lowest bin
		double max = 1.0; // the top of the highest bin
		int number = 10; // the number of bins
		
		HistogramDataset dataset = new HistogramDataset();
		dataset.setType(HistogramType.RELATIVE_FREQUENCY);
		dataset.addSeries("SampleUniform",value,number,min,max);
		
		// Create a chart object
		String plotTitle = "Sample histogram"; // the title of the plot
		String xLabel = "value"; // the label on the x axis
		String yLabel = "n"; // the label on the y axis
		PlotOrientation orientation = PlotOrientation.VERTICAL; 
		boolean showLegend = false; // show the legend on the plot?
		boolean toolTips = false; // generate tooltips?
		boolean urls = false; // generate url's?
		JFreeChart chart = ChartFactory.createHistogram(
				plotTitle, xLabel, yLabel, 
				dataset, 
				orientation, showLegend, toolTips, urls);
		
		// Generate an image from the chart object
		String imageFileName = StringUtil.getFileName("png"); // the file name of the sample created image
		int imageWidth = 500; // The width of the image in pixels
		int imageHeight = 300; // The height of the imags in pixels
		try {
			ChartUtilities.saveChartAsPNG(new File(imageFileName), chart, imageWidth, imageHeight);
		} catch (IOException e) {
			throw new Error(e);
		}
		
		
	}


}
