package gov.fnal.eag.util.jdbc;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import uk.ac.starlink.table.StarTable;
import uk.ac.starlink.table.TableFormatException;

/**
 * manages the creation of a Connection to a MySQL server
 * @author stoughto
 * 
 *
 */
public class MySQLConnection {

	/**
	 * 
	 * @return the connection
	 */
	public static Connection getConnection() {
		String connectionString = getConnectionString();
		return getConnection(connectionString);
	}
	/**
	 * @param connectionString
	 * @return the connection
	 */
	public static Connection getConnection(String connectionString) {
		String mysqlClass = "com.mysql.jdbc.Driver";
		try {
			Class.forName(mysqlClass);
		} catch (ClassNotFoundException e) {
			throw new Error(e);
		}
		System.out.println(" connectionString="+connectionString);
		Connection conn = null;
		try {
			conn = DriverManager.getConnection(connectionString);
		} catch (SQLException e) {
			try {
				conn = DriverManager.getConnection(connectionString, "stoughto", "123456");
			} catch (SQLException e1) {
				throw new Error(e1);
			}
		}
		return conn;
	}

	private static String getConnectionString() {
		String connectionString = 	"jdbc:mysql://localhost/test";
		return connectionString;
	}

	
	/**
	 * run a sample query on the idproc table and print the results
	 * @param args ignored
	 */
	public static void main(String[] args) {
		Connection conn = getConnection();
		System.out.println("conn="+conn);
		
	}		
	
	/**
	 * @param query
	 * @return the resulting table
	 * @throws TableFormatException
	 * @throws IOException
	 */
	public static StarTable getStarTable(String query) throws TableFormatException, IOException {
		getConnection();
		String connectionString = getConnectionString();
	   	String databaseUrl = connectionString+"#"+query;
		StarTableFactory starTableFactory = new StarTableFactory(false);
		StarTable retval = starTableFactory.makeStarTable(databaseUrl);
		return retval;
	}
}
