package gov.fnal.eag.util.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * demonstrate how to use to use the OracleConnection class
 * @author stoughto
 *
 */
public class OracleDemo {
	int objid;
	int imgid;
	double ra;
	double dec;

	/**
	 * run a cone search query
	 * @param ra_in degrees
	 * @param dec_in degrees
	 * @param rad_in in arcminutes
	 * @throws Exception
	 */
	public OracleDemo(double ra_in, double dec_in, double rad_in) throws Exception {
		System.out.println("OracleDemo: before getConnection");
		Connection conn = OracleConnection.getConnection();
		System.out.println("OracleDemo: after getConnection");
		Statement stmt = conn.createStatement();
		String qryStr = "select a.object_id, b.imageid, b.alpha_j2000, b.delta_j2000 " +
		"from table(fGetNearbyEQ(" + ra_in + ", " + dec_in + ", " + rad_in + ")) a, objects b " +
		"where a.object_id = b.object_id";
		System.out.println(" now run qryStr="+qryStr);
		ResultSet rs = stmt.executeQuery(qryStr);
		while (rs.next()) {
			objid = rs.getInt(1);
			imgid = rs.getInt(2);
			ra = rs.getDouble(3);
			dec = rs.getDouble(4);
			System.out.println(objid + ", " + imgid + ", " + ra + ", " + dec);
		}
	}
	/**
	 * run the demo
	 * @param args ignored
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception
	{
		try {
			double ra_in = 345;
			double dec_in = -45.0;
			double rad_in = 0.5;
			new OracleDemo(ra_in, dec_in, rad_in);
		}
		catch (NumberFormatException nfe) {
			System.out.println("NumberFormatException: " + nfe.getMessage());
		}
	}


}
