package gov.fnal.eag.util.minuitDemo;

import org.freehep.math.minuit.FunctionMinimum;
import org.freehep.math.minuit.MinosError;
import org.freehep.math.minuit.MnMigrad;
import org.freehep.math.minuit.MnMinos;
import org.freehep.math.minuit.MnUserParameters;

/**
 *
 * @version $Id: Quad1FMain.java,v 1.1 2007/01/12 15:54:10 dcharms Exp $
 */
public class Quad1FMain
{
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{   
		{
			//test constructor
			Quad1F fcn = new Quad1F();
			MnUserParameters upar = new MnUserParameters();
			upar.add("x", 1., 0.1);
			MnMigrad migrad = new MnMigrad(fcn, upar);
			migrad.setUseAnalyticalDerivatives(false);
			FunctionMinimum min = migrad.minimize();
			System.out.println("min= "+min);
		}
		{
			// using VariableMetricMinimizer, analytical derivatives
			Quad1F fcn = new Quad1F();
			MnUserParameters upar = new MnUserParameters();
			upar.add("x", 1., 0.1);
			MnMigrad migrad = new MnMigrad(fcn, upar);
			FunctionMinimum min = migrad.minimize();
			System.out.println("min= "+min);
		}
		{
			Quad1F fcn = new Quad1F();
			MnUserParameters upar = new MnUserParameters();
			upar.add("x", 1., 0.1);
			MnMigrad migrad = new MnMigrad(fcn, upar);
			FunctionMinimum min = migrad.minimize();
			MnMinos minos = new MnMinos(fcn, min);
			MinosError me = minos.minos(0);
			System.out.printf("par0: %g %g %g\n",min.userState().value(0),me.lower(),me.upper());

			MinosError me2 = minos.minos(0, 4.);
			System.out.printf("par0: %g %g %g\n",min.userState().value(0),me2.lower(),me2.upper());
		}

	}

}
