package gov.fnal.eag.util.minuitDemo;

import org.freehep.math.minuit.FCNBase;
import org.freehep.math.minuit.FunctionMinimum;
import org.freehep.math.minuit.MnMigrad;
import org.freehep.math.minuit.MnUserParameters;

/**
 * @author dcharms
 *
 */
public class Trivial {

	/**
	 * @return the minimum value of the function y = 1+x*x
	 */
	public static double run() {
		FCNBase myFunction = new FCNBase()
		{
			public double valueOf(double[] par)
			{
				double x = par[0];
				return 1 + x*x;
			}
		};
		MnUserParameters myParameters = new MnUserParameters();
		myParameters.add("x", 1., 0.1);

		MnMigrad migrad = new MnMigrad(myFunction, myParameters);
		FunctionMinimum min = migrad.minimize();

		//System.out.printf("Minimum value is %g found using %d function calls", min.fval(),min.nfcn());
		return min.fval();
	}
}
