package gov.fnal.eag.util.misc;

/**
 * execute a command line, and read from stderr and stdout
 * @author stoughto
 * shamelessly copied from http://www.programmebase.com/21/blocking-with-runtime.exec-214646.shtm
 * post by yury.shatz
 *
 */
public class CommandLineStderrStdout {
	/**
	 * @param command elements of the command to be executed
	 * @return the return value, or -1 if the command does not exist
	 */
	public static int run(String[] command) {
		String fullCommand = getFullCommand(command);
		System.out.println("CommandLineStderrStdout.run:  fullCommand="+fullCommand);
		int result;
		//		prepare buffers for process output and error streams
		StringBuffer err=new StringBuffer();
		StringBuffer out=new StringBuffer();
		try {
			Process proc=Runtime.getRuntime().exec(command);
			//			create thread for reading inputStream (process' stdout)
			StreamReaderThread outThread=new StreamReaderThread(proc.getInputStream(),out);
			//			create thread for reading errorStream (process' stderr)
			StreamReaderThread errThread=new StreamReaderThread(proc.getErrorStream(),err);
			//			start both threads
			outThread.start();
			errThread.start();
			//			wait for process to end
			result=proc.waitFor();
			//			finish reading whatever's left in the buffers
			outThread.join();
			errThread.join();
			System.out.println("Process output:\n"+out.toString());
			System.err.println("Process error:\n"+err.toString());
			//System.out.println("Return Value is "+result);
		} catch (Exception e) {
			System.out.println("Error executing "+command[0]);
			result = -1;
		}
		return result;
	}

	/**
	 * @param command
	 * @return the command in one line
	 */
	public static String getFullCommand(String[] command) {
		String commandLine = "";
		for (String commandToken : command) {
			commandLine += commandToken+" ";
		}
		return commandLine;
	}
}