package gov.fnal.eag.util.misc;

import java.util.Arrays;

/**
 * interpolate
 * @author stoughto
 *
 */
public class Interpolator {

	/**
	 * @param x array of x values
	 * @param y array of y values
	 * @param xLookup where to get the y value
	 * @return the y value, or zero of xLookup is not bounded by the x values
	 */
	public static double linear(double[] x, double[] y, double xLookup) {
		int index = Arrays.binarySearch(x, xLookup);
		double retval;
		if (index >= 0) {
			retval = y[index];
		} else {
			int i = -1 - index;
			if (i == 0 || i == x.length) {
				retval = 0.0;
			} else {
				double slope = (y[i] - y[i - 1]) / (x[i] - x[i - 1]);
				retval = y[i-1] + slope	* (xLookup - x[i - 1]);
			}
		}
		return retval;
	}
}
