package gov.fnal.eag.util.misc;

import java.io.IOException;

import gov.fnal.eag.util.yanny.Table;
import uk.ac.starlink.table.RowListStarTable;
import uk.ac.starlink.table.StarTableFactory;
import uk.ac.starlink.table.TableFormatException;

/**
 * utilities to help with jdbc use
 * @author stoughto
 *
 */
public class JDBCUtil {
	/**
	 * create a RowListStarTable from a query and print a message about the number of rows returned
	 * @param args the query
	 */
	public static void main(String[] args) {
		String query = "";
		for (String arg : args) {
			query += arg+" ";
		}
		System.out.println("begin JDBCUtil.main with query="+query);
		loadJdbcDriver(query);
		StarTableFactory starTableFactory = new StarTableFactory(true);
		try {
			RowListStarTable rlst  = Table.makeRowListStarTable(starTableFactory.makeStarTable(query));
			System.out.println(" number of rows:  "+rlst.getRowCount());
		} catch (TableFormatException e) {
			throw new Error(e);
		} catch (IOException e) {
			throw new Error(e);
		}
	}
	
	/**
	 * load the driver for this url
	 * 
	 * @param url
	 */
	public static void loadJdbcDriver(String url) {
		if (url.startsWith("jdbc")) {
			String[] urlWords = url.split(":");
			if (urlWords[1].equalsIgnoreCase("postgresql")) {
				try {
					Class.forName("org.postgresql.Driver");
				} catch (ClassNotFoundException e) {
					throw new Error(e);
				} // load the driver for postgresql
			} else if (urlWords[1].equalsIgnoreCase("mysql")) {
				try {
					Class.forName("com.mysql.jdbc.Driver");
				} catch (ClassNotFoundException e) {
					throw new Error(e);
				} // load the driver for MySQL
			} else {
				throw new Error(" can not load driver for " + url);
			}
		}
	}


}
