package gov.fnal.eag.util.misc;

import java.util.logging.ConsoleHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * treats Logger and Handler at equal levels
 * @author stoughto
 *
 */
public class LoggerUtil {

	/**
	 * 
	 * @param name
	 * @return a logger with a ConsoleHandler, both set to Level.CONFIG
	 */
	public static Logger getLogger(String name) {
		Logger retval = Logger.getLogger(name);
		retval.setLevel(Level.CONFIG);
		Handler handler = new ConsoleHandler();
		handler.setLevel(Level.CONFIG);
		retval.addHandler(handler);
		return retval;
	}
	
	/**
	 * @param logger
	 * @param level to set the logger and all its handlers
	 */
	public static void setLevel(Logger logger, Level level) {
		for (Handler handler : logger.getHandlers()) {
			handler.setLevel(level);
		}
		logger.setLevel(level);
	}

	/**
	 * @param logger
	 * @param loggerLevel one of SEVERE, WARNING, INFO, CONFIG, FINE, FINER, FINEST
	 */
	public static void setLevel(Logger logger, String loggerLevel) {
		if (loggerLevel.equalsIgnoreCase("SEVERE")) {
			LoggerUtil.setLevel(logger, Level.SEVERE);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("WARNING")) {
			LoggerUtil.setLevel(logger, Level.WARNING);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("INFO")) {
			LoggerUtil.setLevel(logger, Level.INFO);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("CONFIG")) {
			LoggerUtil.setLevel(logger, Level.CONFIG);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("FINE")) {
			LoggerUtil.setLevel(logger, Level.FINE);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("FINER")) {
			LoggerUtil.setLevel(logger, Level.FINER);
			return;
		}
		if (loggerLevel.equalsIgnoreCase("FINEST")) {
			LoggerUtil.setLevel(logger, Level.FINEST);
			return;
		}
	}

}
