package gov.fnal.eag.util.misc;


/**
 * convenience methods for reporting memory use
 * @author stoughto
 *
 */
public class Memory {
    private static final Runtime runtime = Runtime.getRuntime ();
    /**
     * @return used memory
     */
    public static long usedMemory () {
    	runtime.gc();
    	return runtime.totalMemory () - runtime.freeMemory ();
    }
    /**
     * @return free memory
     */
    public static long freeMemory () {
    	runtime.gc();
    	return runtime.freeMemory ();
    }
    
    /**
     * @return total memory
     */
    public static long totalMemory() {
    	runtime.gc();
    	return runtime.totalMemory();
    }
    
    /**
     * @return the maximum memory allowed
     */
    public static long maxMemory() {
    	runtime.gc();
    	return runtime.maxMemory();
    }

    /**
     * @return the remaining amount of memory
     */
    public static long availableMemory() {
    	runtime.gc();
    	return maxMemory()-usedMemory();
    }
    /**
     * @return info on memory use
     */
    public static String report() {
    	
    	return String.format(" Memory.report():  max=%,d  available=%,d",maxMemory(),availableMemory());
    }
}
