package gov.fnal.eag.util.plot;


import java.io.File;
import java.util.Collection;
import java.util.Iterator;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 * produce an XY plot in a JPEG file
 * @author stoughto
 *
 */
public class XY {
	/**
	 * @param info title, xLabel, yLabel, fileName
	 * @param x x positions
	 * @param y y positions
	 * @throws Exception if there is trouble
	 */
	public static void png(String[] info, Collection<Double> x, Collection<Double> y) throws Exception {
		if (info == null) {
			throw new Exception("info can not be null");
		}
		if (info.length != 4) {
			throw new Exception("info needs to have length of 4 instead of "+info.length);
		}
		XYSeries xySeries = new XYSeries(info[0]);
		xySeries.setDescription("xySeries");
		Iterator<Double> xIterator = x.iterator();
		Iterator<Double> yIterator = y.iterator();
		for (int i=0; i<x.size(); i++) {
			xySeries.add((xIterator.next()).doubleValue(), (yIterator.next()).doubleValue());
		}
		XYDataset xySeriesCollection =  new XYSeriesCollection(xySeries);
		//xySeriesCollection.addSeries(xySeries);
		JFreeChart chart = ChartFactory.createScatterPlot(info[0], info[1], info[2], xySeriesCollection, PlotOrientation.VERTICAL, true, true, true);
		ChartUtilities.saveChartAsPNG(new File(info[3]), chart, 500, 300);
	}
}
