package gov.fnal.eag.wcs;


import nom.tam.fits.Header;

/**
 * @author stoughto
 *
 */
public interface Transform {
	

	/**
	 * apply the forward transformation:  pixel to world
	 * @param coordinate point to transform
	 * @return the transformed coordinate
	 */
	public SphericalCoordinate forward(Coordinate coordinate);
	/**
	 * apply the inverse transformation: world to pixel
	 * @param coordinate point to transform
	 * @return the transformed coordinate
	 */
	public Coordinate inverse(SphericalCoordinate coordinate);
	
	/**
	 * write WCS information to the header
	 * @param header 
	 */
	public void toHeader(Header header);
	
	
	/**
	 * uses the determinant of the rotation matrix to
	 * @return average pixel size, in arcseconds
	 */
	public double arcsecPerPixel();
	
}
