package jfftw.test;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import jfftw.ArrayUtil;
import jfftw.FFTW;
import jfftw.FFTWComplex;
import junit.framework.TestCase;
/**       Test program to open FFTW and read a specified Wisdom
 *        file.
 */

public class TwoDimensionTest extends TestCase{
	public void testTransform() {
		int width = 500;                  // Size of array
		int height = 300;

		//             Make complex array (twice the size)
		double[] data = new double[2*width*height];

		//        Fill both parts with random using the ArrayUtil
		//        class to do the indexing.
		for(int i = 0; i < width*height; i++) {
		    ArrayUtil.setComplex(data,i,Math.random(),Math.random());
		}

		//          Form the FFTWComplex do do the work
		FFTWComplex fft = new FFTWComplex();


		//    Take out-of -place forward fft, does not alter the data[]
		//    array.
		double[] ft = fft.twoDimensional(width,height,data,1,false);
	       
		//    Take in place backwords fft  
		fft.twoDimensional(width,height,ft,-1,true);
		
		// Normalise...   (no default normalsiation when using FFTW)
		
		ArrayUtil.mult(ft,1.0/(width*height));

		//   Check difference by comparing the modulus of each element.
		double diff = 0;
		for(int i = 0; i < width*height; i++) {
		    double d = ArrayUtil.getComplex(data,i).modulus() -
			ArrayUtil.getComplex(ft,i).modulus();
		    diff += Math.abs(d);
		}

		//         Print out the difference.... shoul be small.
		System.out.println("Difference is : " + diff);

		assertTrue(diff < 1e-10);


	}
}