package jfftw.test;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import jfftw.FFTW;
import junit.framework.TestCase;
/**       Test program to open FFTW and read a specified Wisdom
 *        file.
 */

public class WisdomTest extends TestCase{
	public static void testStaticGetWisdom() {
		
		String w = FFTW.readWisdom(new File("wisdom-E6700"));
		FFTW.writeWisdom(w,new File("test"));	
		String w2 = FFTW.readWisdom(new File("test"));
		assertTrue(w.equals(w2));

		FFTW f = new FFTW();
		f.loadWisdom(w);
		String wisdom = f.getWisdom();
		
		System.out.println("BBB wisdom="+wisdom);
		System.out.println("wisdom length is " + wisdom.length());
		System.out.println("     w length is " + w.length());
	}

    public static void testGetWisdom() throws IOException {
    	InputStream inputStream = WisdomTest.class.getResourceAsStream("wisdom-E6700");
		BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
		String[] args = {"/tmp/tempWisdomFile"};
		PrintWriter pw = new PrintWriter(new FileWriter(args[0]));
		String line;
		while ((line = bufferedReader.readLine()) != null) {
			pw.println(line);
		}
		pw.close();
		
		System.out.println("now call FFTW(args[0]) "+args[0]);
		
		//            Form FFTW with specifed wisdon file (by name)
		FFTW fft = new FFTW(args[0]);
		//FFTW fft = new FFTW();
		//fft.loadWisdom(args[0]);
		
		//           Print to standard output.
		String w = FFTW.readWisdom(new File("wisdom-E6700"));
		assertEquals(w,fft.getWisdom());
    }
}