package jsky.coords.test;

import jsky.coords.WorldCoords;
import junit.framework.TestCase;

/**
 * test methods that were added to the WorldCoords class
 * @author stoughto
 *
 */
public class WorldCoordsTest extends TestCase {
	/**
	 * test the steradians method
	 */
	public void testSteradians() {
		// 1/8 of the sphere
		{
			WorldCoords pos1 = new WorldCoords(0.0, 0.0);
			WorldCoords pos2 = new WorldCoords(90.0, 90.0);
			{ 
				double steradians = WorldCoords.steradians(pos1, pos2);				
				double truth = 4 * Math.PI / 8.0;
				assertEquals(truth, steradians);		
			}
			{
				double steradians = WorldCoords.steradians(pos2, pos1);
				double truth = 4 * Math.PI * (3.0/8.0);
				assertEquals(truth, steradians);			
			}
		}
		// rotate by 10 degrees in ra
		{
			WorldCoords pos1 = new WorldCoords(-10.0, 0.0);
			WorldCoords pos2 = new WorldCoords(80.0, 90.0);
			{ 
				double steradians = WorldCoords.steradians(pos1, pos2);				
				double truth = 4 * Math.PI / 8.0;
				assertEquals(truth, steradians);		
			}
			{
				double steradians = WorldCoords.steradians(pos2, pos1);
				double truth = 4 * Math.PI * (3.0/8.0);
				assertEquals(truth, steradians);			
			}
			
		}
		// express -10 degrees in ra as 350 degrees
		{
			WorldCoords pos1 = new WorldCoords(350.0,  0.0);
			WorldCoords pos2 = new WorldCoords( 80.0, 90.0);
			{ 
				double steradians = WorldCoords.steradians(pos1, pos2);				
				double truth = 4 * Math.PI / 8.0;
				assertEquals(truth, steradians);		
			}
			{
				double steradians = WorldCoords.steradians(pos2, pos1);
				double truth = 4 * Math.PI * (3.0/8.0);
				assertEquals(truth, steradians);			
			}
			
		}
	}
}
