package snap.snoop.framework.visualize;

import hep.aida.ref.plotter.PlotterUtilities;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;

import snap.snoop.framework.visualize.SubPlot;

/**
 * @author hshukla
 */
public class VisualizeFrame extends JFrame
{
	JDialog dialog = null;

	private SubPlot s = null;

    private String[] buttons = null;

    private String buttonName = null;
    
    public VisualizeFrame (SubPlot $s, String[] $buttons)
    {
        super($s.getWindowTitle());

        s = $s;

        buttons = $buttons;
        buttonName = buttons[0];
    }

    public void setButtonDefault(int i) 
    {
    	buttonName = buttons[i];
    }
    /**
     * On close, the first button is selected, unless a different default is 
     * given
     */
    public void display()
    {
		dialog = new JDialog(JOptionPane.getRootFrame(), s.getWindowTitle(), true);

//		dialog.getContentPane().add(PlotterUtilities.componentForPlotter(s.getPlotter()));
//		dialog.getContentPane().add(this);
		
        frameLayout(dialog.getContentPane());

//		dialog.pack();

		dialog.addWindowListener(new CloseWindowAdapter(this, dialog));
		
//        dialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
//        this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

		dialog.pack();
		
		dialog.show();
    }

    /**
     * @throws IllegalArgumentException
     */
    private void frameLayout(Container container) throws IllegalArgumentException
    {
        container.setLayout(new GridBagLayout());
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LAST_LINE_START;

        for (int i = 0; i < buttons.length; i++)
        {
            gridBagConstraints.gridx = i;
            gridBagConstraints.gridy = 1;
            container.add(createButton(buttons[i]), gridBagConstraints);
        }

        // Now embed the plotter
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.gridheight = 1;

        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
//        setDefaultCloseOperation(EXIT_ON_CLOSE);
        container.add(
                PlotterUtilities.componentForPlotter(s.getPlotter()),
                gridBagConstraints);
        pack();
    }

    //JButton factory
    private JButton createButton(final String name)
    {
        JButton button = new JButton();
        button.setText(name);

        button.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent evt)
            {
                setReturnButtonName(name);
            }
        });

        return button;
    }

    private void setReturnButtonName(String name)
    {
        //System.out.print (name);
        buttonName = name;

        //kill frame
        dialog.hide();
        dialog.dispose();
        this.dispose();
    }

    public String getButtonName()
    {
        return buttonName;
    }
    
    private static class CloseWindowAdapter extends WindowAdapter
    {
    	JDialog dialog = null;
    	JFrame  frame  = null;
    	
    	public
    	CloseWindowAdapter(JFrame $frame, JDialog $dialog)
    	{
    		super();
    		
    		dialog = $dialog;
    		frame  = $frame;
    	}
    	
    	public void windowClosing(WindowEvent e) {
            //kill frame
            dialog.hide();
            dialog.dispose();
            frame.dispose();
    	}
    }
}

