#!/bin/sh
#
# Executes a class defined by the files in LIB_DIR
#
if [ $# -lt 2 ]
then
	echo Usage:  eagRunner.sh LIB_DIR className [arguments]
	echo If you want more memory, use -Xmx1000m as the first argument to get 1 Gbyte of memory
	exit 1
fi

# Find out where the .jar files are
export LIB_DIR=$1
if [ ! -d $LIB_DIR ]
then
	echo Error:  does not exist LIB_DIR=$LIB_DIR
	exit 1
fi

# Build up a classpath from the jar files
for file in `ls $LIB_DIR`
do
  export cp=$cp:$LIB_DIR/$file
done

# Run the program
shift
java -cp $cp $*

# Return the return code from the java command
exit $?

